#ifdef LINUX

#define SDK_API __attribute__ ((visibility("default")))
#define CALL_STACK
#define TCHAR char
#else

#include <tchar.h>
#ifdef EXPORT_CDECL
#define CALL_STACK __cdecl
#else
#define CALL_STACK __stdcall
#endif

#ifdef __cplusplus
#define SDK_API extern "C" __declspec(dllexport)
#else
#define SDK_API __declspec(dllexport)
#endif

#endif

SDK_API void CALL_STACK FormatError( int errorNo, int langid, unsigned char* buf, int pos, int bufSize );
SDK_API int CALL_STACK PrinterCreator( void** phandle, const TCHAR* model );
SDK_API int CALL_STACK SetLog(int enable, const TCHAR* path);
SDK_API void* CALL_STACK PrinterCreatorS(const TCHAR* model );
SDK_API int CALL_STACK PrinterDestroy( void* handle );
SDK_API int CALL_STACK PortOpen( void* handle, const TCHAR* ioSettings );
SDK_API int CALL_STACK DriverPortOpen( void* handle, const TCHAR* driverName );
SDK_API int CALL_STACK PortClose( void* handle );
SDK_API int CALL_STACK DirectIO( void* handle, unsigned char* writeData, unsigned int writeNum, unsigned char* readData, unsigned int readNum, unsigned int* preadedNum );
SDK_API int CALL_STACK WriteData( void* handle, unsigned char* writeData, unsigned int writeNum );
SDK_API int CALL_STACK ReadData( void* handle, unsigned char* readData, unsigned int readNum, unsigned int* preadedNum );

SDK_API int CALL_STACK CPCL_AddLabel( void* handle, int offSet, int height, int qty );
SDK_API int CALL_STACK CPCL_SetAlign( void* handle, int align );
SDK_API int CALL_STACK CPCL_AddText( void* handle, int rotate, int fontType, int fontSize, int xPos, int yPos, const TCHAR* data );
SDK_API int CALL_STACK CPCL_AddBarCode( void* handle, int rotate, int type, float width, int ratio, float height, int xPos, int yPos, const TCHAR* data );
SDK_API int CALL_STACK CPCL_AddBarCodeText( void* handle, int enable, int fontType, int fontSize, int offSet );
SDK_API int CALL_STACK CPCL_AddQRCode( void* handle, int rotate, int xPos, int yPos, int model, int unitWidth, int eccLevel, const TCHAR* data );
SDK_API int CALL_STACK CPCL_AddPDF417( void* handle, int rotate, int xPos, int yPos, int xDots, int yDots, int columns, int rows, int eccLevel, const TCHAR* data );
SDK_API int CALL_STACK CPCL_AddBox( void* handle, int xPos, int yPos, int endXPos, int endYPos, int thickness );
SDK_API int CALL_STACK CPCL_AddLine( void* handle, int xPos, int yPos, int endXPos, int endYPos, int thickness );
SDK_API int CALL_STACK CPCL_AddImage( void* handle, int rotate, int xPos, int yPos, const TCHAR* imagePath );
SDK_API int CALL_STACK CPCL_AddImageData( void* handle, int rotate, int widthBytes, int height, int xPos, int yPos, const char* data );

/* Setting */
SDK_API int CALL_STACK CPCL_SetFontSize( void* handle, int width, int height );
SDK_API int CALL_STACK CPCL_SetDensity( void* handle, int density );
SDK_API int CALL_STACK CPCL_SetSpeed( void* handle, int speed );
SDK_API int CALL_STACK CPCL_SetTextSpacing( void* handle, int spacing );
SDK_API int CALL_STACK CPCL_SetLeftMargin( void* handle, int margin );
SDK_API int CALL_STACK CPCL_SetTextBold( void* handle, int bold );
SDK_API int CALL_STACK CPCL_SetTextUnderline( void* handle, int underline );

/* control */
SDK_API int CALL_STACK CPCL_Abort( void* handle );
SDK_API int CALL_STACK CPCL_Print( void* handle );
SDK_API int CALL_STACK CPCL_NextLabelPos( void* handle ); /* FORM */
SDK_API int CALL_STACK CPCL_PreFeed( void* handle, int distance );
SDK_API int CALL_STACK CPCL_PostFeed( void* handle, int distance );
/* SDK_API int CALL_STACK CPCL_GetStatus(void* handle); */
#endif