﻿using System;

using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace CPCL_DEMO
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            int Result = 0;
            cpcl_dll dll = new cpcl_dll();

            dll.printer = cpcl_dll.PrinterCreatorS("HM-A300");
            if (0 != dll.printer)
            {
                Result = cpcl_dll.PortOpen(dll.printer, "BT,0015833E9496");
                if (0 == Result)
                {
                    //设置标签大小和打印的数量
                    Result = cpcl_dll.CPCL_AddLabel(dll.printer, 0, 1200, 1);
                    //设置文本对齐方式
                    Result = cpcl_dll.CPCL_SetAlign(dll.printer, 1);
                    //打印文本
                    Result = cpcl_dll.CPCL_AddText(dll.printer, 0, 7, 2, 10, 5, "你好");
                    Result = cpcl_dll.CPCL_AddText(dll.printer, 0, 7, 2, 10, 25, "hello");
                    Result = cpcl_dll.CPCL_AddText(dll.printer, 0, 7, 2, 10, 45, "こんにちは");
                    //注释条码
                    Result = cpcl_dll.CPCL_AddBarCodeText(dll.printer, 1, 7, 0, 5);
                    //打印Code 128条码
                    Result = cpcl_dll.CPCL_AddBarCode(dll.printer, 0, 0, 1.0F, 1, 50.0F, 10, 80, "123456789");
                    //打印Code 39条码
                    Result = cpcl_dll.CPCL_AddBarCode(dll.printer, 0, 5, 1.0F, 1, 50.0F, 10, 180, "66886868");
                    //打印Code 93条码
                    Result = cpcl_dll.CPCL_AddBarCode(dll.printer, 0, 7, 1.0F, 1, 50.0F, 10, 280, "88886666");
                    //打印EAN 13条码
                    Result = cpcl_dll.CPCL_AddBarCode(dll.printer, 0, 10, 1.0F, 1, 50.0F, 10, 380, "012345678901");
                    //打印EAN 8条码
                    Result = cpcl_dll.CPCL_AddBarCode(dll.printer, 0, 13, 1, 1, 50, 10, 480, "1234567");
                    //打印二维条码
                    Result = cpcl_dll.CPCL_AddQRCode(dll.printer, 0, 10, 580, 2, 6, 1, "1010011110");
                    //打印PDF417二维条码
                    Result = cpcl_dll.CPCL_AddPDF417(dll.printer, 0, 10, 750, 2, 6, 8, 8, 1, "0010101101");
                    //画框
                    Result = cpcl_dll.CPCL_AddBox(dll.printer, 10, 820, 40, 880, 1);
                    //画线
                    Result = cpcl_dll.CPCL_AddLine(dll.printer, 10, 900, 80, 970, 3);
                    //打印图片
                    Result = cpcl_dll.CPCL_AddImage(dll.printer, 0, 10, 980, "\\Program Files\\CPCL_DEMO\\1.bmp");
                    //设置打印浓度
                    Result = cpcl_dll.CPCL_SetDensity(dll.printer, 3);
                    //设置字体加粗浓度
                    Result = cpcl_dll.CPCL_SetTextBold(dll.printer, 3);
                    //打印标签
                    Result = cpcl_dll.CPCL_Print(dll.printer);
                    //关闭端口
                    Result = cpcl_dll.PortClose(dll.printer);
                    //销毁
                    Result = cpcl_dll.PrinterDestroy(dll.printer);
                }
                else
                {
                    MessageBox.Show("Port open failed,please check the port settings");
                    return;
                }
            }
            else
            {
                MessageBox.Show("Printer Device not found");
            }
        }
    }
    public class cpcl_dll
    {
        [DllImport("CPCL_SDK")]
        public static extern int PrinterCreator(ref IntPtr printer, string model);

        [DllImport("CPCL_SDK")]
        public static extern int PrinterCreatorS(string model);

        [DllImport("CPCL_SDK")]
        public static extern int PrinterDestroy(int printer);

        [DllImport("CPCL_SDK")]
        public static extern int PortOpen(int printer, string ioSettings);

        [DllImport("CPCL_SDK")]
        public static extern int PortClose(int printer);

        [DllImport("CPCL_SDK")]
        public static extern int DirectIO(int printer, byte[] writedata, int wirteNum, byte[] readdata, int readNum, ref int preadedNum);

        [DllImport("CPCL_SDK")]
        public static extern int CPCL_AddLabel(int printer, int offSet, int height, int qty);

        [DllImport("CPCL_SDK")]
        public static extern int CPCL_SetAlign(int printer, int align);

        [DllImport("CPCL_SDK")]
        public static extern int CPCL_AddText(int printer, int rotate, int fontType, int fontSize, int xPos, int yPos, string data);

        [DllImport("CPCL_SDK")]
        public static extern int CPCL_AddBarCode(int printer, int rotate, int type, float width, int ratio, float height, int xPos, int yPos, string data);

        [DllImport("CPCL_SDK")]
        public static extern int CPCL_AddBarCodeText(int printer, int enable, int fontType, int fontSize, int offSet);

        [DllImport("CPCL_SDK")]
        public static extern int CPCL_AddQRCode(int printer, int rotate, int xPos, int yPos, int model, int unitWidth, int eccLevel, string data);

        [DllImport("CPCL_SDK")]
        public static extern int CPCL_AddPDF417(int printer, int rotate, int xPos, int yPos, int xDots, int yDots, int columns, int rows, int eccLevel, string data);

        [DllImport("CPCL_SDK")]
        public static extern int CPCL_AddImage(int handle, int rotate, int xPos, int yPos, string imagePath);

        [DllImport("CPCL_SDK")]
        public static extern int CPCL_AddBox(int printer, int xPos, int yPos, int endXPos, int endYPos, int thickness);

        [DllImport("CPCL_SDK")]
        public static extern int CPCL_AddLine(int printer, int xPos, int yPos, int endXPos, int endYPos, int thickness);

        [DllImport("CPCL_SDK")]
        public static extern int CPCL_SetFontSize(int printer, int width, int height);

        [DllImport("CPCL_SDK")]
        public static extern int CPCL_SetDensity(int printer, int density);

        [DllImport("CPCL_SDK")]
        public static extern int CPCL_SetSpeed(int printer, int speed);

        [DllImport("CPCL_SDK")]
        public static extern int CPCL_SetTextSpacing(int printer, int Spacing);

        [DllImport("CPCL_SDK")]
        public static extern int CPCL_SetTextBold(int printer, int bold);

        [DllImport("CPCL_SDK")]
        public static extern int CPCL_SetTextUnderline(int printer, int underline);

        [DllImport("CPCL_SDK")]
        public static extern int CPCL_Print(int printer);

        [DllImport("CPCL_SDK")]
        public static extern int CPCL_NextLabelPos(int printer);

        [DllImport("CPCL_SDK")]
        public static extern int CPCL_PreFeed(int printer, int distance);

        [DllImport("CPCL_SDK")]
        public static extern int CPCL_PostFeed(int printer, int distance);

        public int printer;
    }
}